	processor 6502

PAL	equ	0			; 0 = NTSC (262 scanlines), 1 = PAL (312 scanlines)

VSYNC	equ	$00
VBLANK	equ	$01
WSYNC	equ	$02
COLUBK	equ	$09

AUDC0	equ	$15
AUDC1	equ	$16
AUDF0	equ	$17
AUDF1	equ	$18
AUDV0	equ	$19
AUDV1	equ	$1a

INTIM	equ	$0284
TIM8T	equ	$0295
TIM64T	equ	$0296

	IF PAL == 1
PICTOP	equ	48
PICEND	equ	48+228
PLAYER	equ	312-12
	ELSE
PICTOP	equ	40
PICEND	equ	40+192
PLAYER	equ	262-12
	ENDIF


;	Star Bars Atari 2600 Player Example

	org	$f000,$00

	.include "player.s"

	
Reset	subroutine
	ldx	#0			; init TIA, RAM and stack pointer
	txa
.1
	dex
	txs
	pha
	bne	.1

	cld				; clear decimal mode flag

	jsr	PlayerInit		; init player


Frame	subroutine
	ldx	#0			; vblank, scanline counter in x
	stx	VBLANK

	lda	#2			; vsync
	sta	VSYNC
.1	sta	WSYNC
	TiatonicTuning
	inx
	cpx	#3
	bne	.1

	lda	#0			; vsync done
	sta	VSYNC

.2	sta	WSYNC			; upper border loop
	TiatonicTuning
	inx
	cpx	#PICTOP
	bne	.2

	lda	#4			; start of picture area
	sta	COLUBK

.3	sta	WSYNC
	TiatonicTuning
	inx
	cpx	#PICEND&255
	bne	.3

	lda	#0			; end of picture area
	sta	COLUBK

	lda	#%01000010		; enter blanking
	sta	VBLANK

.4	sta	WSYNC			; overscan / lower border
	TiatonicTuning
	inx
	cpx	#PLAYER&255		; PLAYER called 12 scanlines before end of frame
	bne	.4

	lda	#12*76/64		; run timer during last 12 scanlines of overscan
	sta	TIM64T

	jsr	Player			; update player

	IF QUALITY <= $07
	ldx	#0			; if QUALITY is $07 or $03 then we've missed one tiatonic tuning call
	TiatonicTuning			; during player update around scaline 256 (pal 306) so do it now (x = 0)
	ENDIF

.5	lda	INTIM			; wait for timer out
	bne	.5

	sta	WSYNC			; sync at last scanline after timer has run for 12*76 cycles

	jmp	Frame


;	Music Data

	org	$f500-2,$00
	.incbin	"barbie.prg"		; your Star Bars music data here (2 bytes obsolete CBM load address)


;	Frequency Table

	org	$ff00,$00

freqtab
	IF PAL == 1
	.incbin "freq-pal.bin"
	ELSE
	.incbin "freq-ntsc.bin"
	ENDIF


;	Reset Vector

	org	$fffa,$00
	dc.w	Reset, Reset, Reset
